/*************************************************************************************
Data Visualization - ControlP5 Demo                
Tested in Processing 4                                    
                                                     
Author: Yixuan Li                    
Supervisor: George Legrady                           

Purpose: Show how to add GUI control to visualizations    

*************************************************************************************/

// Import library
import peasy.*;
import controlP5.*;

ControlP5 cp5;
PeasyCam cam;

float gray;
float fillColor;
boolean showBox;
void setup(){
  size(800,600,P3D);
  // Set up cameras
  cam = new PeasyCam(this, 200);
  cam.setMinimumDistance(100);
  cam.setMaximumDistance(1000);
  // Set up the GUI
  cp5 = new ControlP5(this);
  gray =128;
  showBox = true;
  fillColor = 255;
  setGui();
}

void draw(){
  background(gray);
  if (showBox == true){
    fill(fillColor);
    box(100);
  }
  gui();
  // Deactivate the camera when the mouse is within the GUI area
  if((mouseX<180)&(mouseY<180)){
    cam.setActive(false);
  }
  else{
    cam.setActive(true);
  }
}
 
void setGui(){
  // Set up the fonts
  PFont pfont = createFont("Arial", 16,true);
  ControlFont font = new ControlFont(pfont, 12);
  float X = 60;
  float distance =40;
  int index = 1;
  // draw the GUI
  cp5.addSlider("gray")
  .setRange(0, 255)
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(100,20);
  index++;
  
  cp5.addToggle("showBox")
  .setFont(font)
  .setPosition(X, distance*index);
  index++;
  
  cp5.addBang("randomizeColor")
  .setFont(font)
  .setPosition(X, distance*index);
  index++;
  
  cp5.addTextlabel("label")
  .setFont(font)
  .setText("Press Space: Show Box")
  .setColorValue(0xffffff00)
  .setPosition(X, index*distance);
  index++;
  
  cp5.setAutoDraw(false);
}

void randomizeColor(){
  gray = random(0,255);
}
// A function for draw GUI correctly
void gui(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
